#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <malloc.h>

typedef struct TgaObject_type 
{	int ResX,ResY;
	short *Data ;
} TgaObject, *TgaObject_ptr;

void DirectLoadTga(char *FileName);
void LoadTga(char *FileName, TgaObject_ptr TgaObject);

// Thake into account that this code was an experiment for me and it is not really good !
// It only loads 640*480 pictures and gives an Error if the file can't be found.
// Call LoadTga by using:
// TgaObject picture; LoadTga("name.tga", &picture);

// Then show it using:
// grLfbWriteRegion(GR_BUFFER_BACKBUFFER,0,0,GR_LFB_SRC_FMT_565,640,480,FXFALSE,1280,picture.Data);


void DirectLoadTga(char *FileName)
{   FILE *fp;
	long count;
	float r,g,b,data;
	int tel,x,y;

	FxU16 pixel;
	GrLfbInfo_t info;
	FxU16 *ptr2;

	fp = fopen(FileName,"rb");
	for (tel=0;tel<18;tel++)
	{	data=(char)getc(fp);
	}
	count=0;

	grLfbLock(	GR_LFB_WRITE_ONLY, GR_BUFFER_BACKBUFFER, GR_LFBWRITEMODE_565, 	GR_ORIGIN_ANY, FXFALSE, &info);
	ptr2 = ptr2 = (unsigned short *)info.lfbPtr;

	for(y=0;y<480;y++)
	{	for(x=0;x<640;x++)
		{	b=(float)getc(fp);
			g=(float)getc(fp);
			r=(float)getc(fp);
			r /=255; r *=31;
			g /=255; g *=63;
			b /=255; b *=31;
			pixel = ((unsigned short)r)<<11 | ((unsigned short)g)<<5 | ((unsigned short)b);
			ptr2[x + (y<<10)] = pixel;
		}
	}

	grLfbUnlock(GR_LFB_WRITE_ONLY, GR_BUFFER_BACKBUFFER);

	fclose(fp);
}

void LoadTga(char *FileName, TgaObject_ptr TgaObject)
{   FILE *fp;

	float r,g,b,data;
	int tel,x,y;
	int NumOfPixels;

	FxU16 pixel;
	short *Buffer;

	fp = fopen(FileName,"rb");
	
	for (tel=0;tel<9;tel++)
	{	data=(short)getw(fp);
		if(tel==6) TgaObject->ResX = data;
		if(tel==7) TgaObject->ResY = data;
	}

	NumOfPixels = 307200;//TgaObject->ResX * TgaObject->ResY;
	Buffer		 = (short *) calloc(NumOfPixels, sizeof(short));
	
	for(y=480-1;y>=0;y--)
	{	for(x=0;x<640;x++)
		{	b=(int)getc(fp);
			g=(int)getc(fp);
			r=(int)getc(fp);
			r /=255; r *=31;
			g /=255; g *=63;
			b /=255; b *=31;
			pixel = ((unsigned short)r)<<11 | ((unsigned short)g)<<5 | ((unsigned short)b);
			Buffer[x + (y*640)] = pixel;
		}
	}

	TgaObject->Data = Buffer;

	fclose(fp);
}
